package com.yice.webadmin.app.controller;

import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.ModelCompressDto;
import com.yice.webadmin.app.dto.ModelEstimateDto;
import com.yice.webadmin.app.dto.ModelTaskDto;
import com.yice.webadmin.app.model.ModelCompress;
import com.yice.webadmin.app.model.ModelEstimate;
import com.yice.webadmin.app.model.ModelTask;
import com.yice.webadmin.app.service.ModelTaskService;
import com.yice.webadmin.app.vo.ModelTaskVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 模型任务操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "模型任务管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/modelTask")
public class ModelTaskController {

    @Autowired
    private ModelTaskService modelTaskService;

    /**
     * 新增模型任务数据，及其关联的从表数据。
     *
     * @param modelTaskDto     新增主表对象。
     * @param modelEstimateDto 一对一模型评估从表Dto。
     * @param modelCompressDto 一对一模型压缩从表Dto。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"modelTaskDto.taskId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(
            @MyRequestBody ModelTaskDto modelTaskDto,
            @MyRequestBody ModelEstimateDto modelEstimateDto,
            @MyRequestBody ModelCompressDto modelCompressDto) {
        ResponseResult<Tuple2<ModelTask, JSONObject>> verifyResult = this.doBusinessDataVerifyAndConvert(
                modelTaskDto, false, modelEstimateDto, modelCompressDto);
        if (!verifyResult.isSuccess()) {
            return ResponseResult.errorFrom(verifyResult);
        }
        Tuple2<ModelTask, JSONObject> bizData = verifyResult.getData();
        ModelTask modelTask = bizData.getFirst();
        modelTask = modelTaskService.saveNewWithRelation(modelTask, bizData.getSecond());
        return ResponseResult.success(modelTask.getTaskId());
    }

    /**
     * 修改模型任务数据，及其关联的从表数据。
     *
     * @param modelTaskDto     修改后的对象。
     * @param modelEstimateDto 一对一模型评估从表Dto。
     * @param modelCompressDto 一对一模型压缩从表Dto。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"modelTaskDto.taskId"})
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Long> update(
            @MyRequestBody ModelTaskDto modelTaskDto,
            @MyRequestBody ModelEstimateDto modelEstimateDto,
            @MyRequestBody ModelCompressDto modelCompressDto) {
        String errorMessage;
        ResponseResult<Tuple2<ModelTask, JSONObject>> verifyResult = this.doBusinessDataVerifyAndConvert(
                modelTaskDto, true, modelEstimateDto, modelCompressDto);
        if (!verifyResult.isSuccess()) {
            return ResponseResult.errorFrom(verifyResult);
        }
        Tuple2<ModelTask, JSONObject> bizData = verifyResult.getData();
        ModelTask originalModelTask = bizData.getSecond().getObject("originalData", ModelTask.class);
        ModelTask modelTask = bizData.getFirst();
        if (!modelTaskService.updateWithRelation(modelTask, originalModelTask, bizData.getSecond())) {
            errorMessage = "数据验证失败，[ModelTask] 数据不存在!";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success(modelTask.getTaskId());
    }

    /**
     * 删除模型任务数据。
     *
     * @param taskId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long taskId) {
        if (MyCommonUtil.existBlankArgument(taskId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(taskId);
    }

    /**
     * 列出符合过滤条件的模型任务列表。
     *
     * @param modelTaskDtoFilter     过滤对象。
     * @param modelEstimateDtoFilter 一对一从表过滤对象。
     * @param modelCompressDtoFilter 一对一从表过滤对象。
     * @param orderParam             排序参数。
     * @param pageParam              分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<ModelTaskVo>> list(
            @MyRequestBody ModelTaskDto modelTaskDtoFilter,
            @MyRequestBody ModelEstimateDto modelEstimateDtoFilter,
            @MyRequestBody ModelCompressDto modelCompressDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        ModelTask modelTaskFilter = MyModelUtil.copyTo(modelTaskDtoFilter, ModelTask.class);
        ModelEstimate modelEstimateFilter = MyModelUtil.copyTo(modelEstimateDtoFilter, ModelEstimate.class);
        ModelCompress modelCompressFilter = MyModelUtil.copyTo(modelCompressDtoFilter, ModelCompress.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, ModelTask.class);
        List<ModelTask> modelTaskList =
                modelTaskService.getModelTaskListWithRelation(modelTaskFilter, modelEstimateFilter, modelCompressFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(modelTaskList, ModelTask.INSTANCE));
    }

    /**
     * 查看指定模型任务对象详情。
     *
     * @param taskId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<ModelTaskVo> view(@RequestParam Long taskId) {
        ModelTask modelTask = modelTaskService.getByIdWithRelation(taskId, MyRelationParam.full());
        if (modelTask == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        ModelTaskVo modelTaskVo = ModelTask.INSTANCE.fromModel(modelTask);
        return ResponseResult.success(modelTaskVo);
    }

    private ResponseResult<Tuple2<ModelTask, JSONObject>> doBusinessDataVerifyAndConvert(
            ModelTaskDto modelTaskDto,
            boolean forUpdate,
            ModelEstimateDto modelEstimateDto,
            ModelCompressDto modelCompressDto) {
        ErrorCodeEnum errorCode = ErrorCodeEnum.DATA_VALIDATED_FAILED;
        String errorMessage = MyCommonUtil.getModelValidationError(modelTaskDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(errorCode, errorMessage);
        }
        errorMessage = MyCommonUtil.getModelValidationError(modelEstimateDto);
        if (errorMessage != null) {
            return ResponseResult.error(errorCode, "参数 [modelEstimateDto] " + errorMessage);
        }
        errorMessage = MyCommonUtil.getModelValidationError(modelCompressDto);
        if (errorMessage != null) {
            return ResponseResult.error(errorCode, "参数 [modelCompressDto] " + errorMessage);
        }
        // 全部关联从表数据的验证和转换
        JSONObject relationData = new JSONObject();
        CallResult verifyResult;
        // 下面是输入参数中，主表关联数据的验证。
        ModelTask modelTask = MyModelUtil.copyTo(modelTaskDto, ModelTask.class);
        ModelTask originalData = null;
        if (forUpdate && modelTask != null) {
            originalData = modelTaskService.getById(modelTask.getTaskId());
            if (originalData == null) {
                return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
            }
            relationData.put("originalData", originalData);
        }
        verifyResult = modelTaskService.verifyRelatedData(modelTask, originalData);
        if (!verifyResult.isSuccess()) {
            return ResponseResult.errorFrom(verifyResult);
        }
        // 处理主表的一对一关联 [ModelEstimate]
        ModelEstimate modelEstimate = MyModelUtil.copyTo(modelEstimateDto, ModelEstimate.class);
        relationData.put("modelEstimate", modelEstimate);
        // 处理主表的一对一关联 [ModelCompress]
        ModelCompress modelCompress = MyModelUtil.copyTo(modelCompressDto, ModelCompress.class);
        relationData.put("modelCompress", modelCompress);
        return ResponseResult.success(new Tuple2<>(modelTask, relationData));
    }

    private ResponseResult<Void> doDelete(Long taskId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        ModelTask originalModelTask = modelTaskService.getById(taskId);
        if (originalModelTask == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelTaskService.remove(taskId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
